// EdgeFile.h: CEdgeFile NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EDGEFILE_H__58FF9A11_F21F_4F03_9F2E_EE961CA3BCCC__INCLUDED_)
#define AFX_EDGEFILE_H__58FF9A11_F21F_4F03_9F2E_EE961CA3BCCC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "EdgeLayer.h"

// bZ[WQ
enum {
	EDGELIB_OK = 0,				// 
	EDGELIB_CANNOT_OPEN,		// t@CI[vo܂ł
	EDGELIB_NOT_EDGE_FILE,		// ̃t@CEDGEt@Cł͂܂
	EDGELIB_IMAGE_NULL,			// C[W܂
	EDGELIB_LAYER_FULL,			// Cȏǉo܂
	EDGELIB_CANNOT_WRITE,		// f[^߂܂
};

// F
class CEdgeColor
{
public:
	BYTE m_btRed;
	BYTE m_btGreen;
	BYTE m_btBlue;
};

// EDGEt@CT|[gNX
class CEdgeFile  
{
// 萔錾
protected:
	enum {
		LAYER_MAX = 128,
		IMAGE_WIDTH_MAX = 4000,
		IMAGE_HEIGHT_MAX = 4000,
	};

// ϐ
protected:
	// C
	CEdgeLayer* m_apLayer[LAYER_MAX];
	// C[W̉
	int m_nWidth;
	// C[W̏c
	int m_nHeight;
	// J[pbg
	CEdgeColor m_acolPalette[256];
	// C
	WORD m_wLayer;
	// F
	BYTE m_btTransColor;


// ǂݍݗp֐
public:
	// ǂݍݎs
	int Read(const char *pszFilename);
	// pbg擾
	CEdgeColor* GetPalette();
	// C擾
	WORD GetLayerCount();
	// 擾
	int GetWidth();
	// c擾
	int GetHeight();
	// C擾
	CEdgeLayer* GetLayer(WORD wIndex);

// op֐
public:
	// C[W̃TCYݒ
	bool SetImageSize(int nWidth, int nHeight);
	// Cǉ
	int AddLayer(BYTE *pbtImage, const char* pszName = NULL, bool bShow = true);
	// pbgݒ
	void SetPalette(CEdgeColor* pcolPalette);
	// Fݒ
	void SetTransColor(BYTE btColor);
	// os
	int Write(const char* pszFilename);

// \zE
public:
	// f[^N[
	void Clean();

	CEdgeFile();
	virtual ~CEdgeFile();
};

#endif // !defined(AFX_EDGEFILE_H__58FF9A11_F21F_4F03_9F2E_EE961CA3BCCC__INCLUDED_)
